clear
%sims=10^6;
sims=10^5;
rng(1);

worker_count=24;
while worker_count>=12
    try
        parpool('local',worker_count)
    end
    n = numlabs;
    if n==worker_count
        worker_count=0;
    else
        worker_count=worker_count-2;
    end
end

    sigma1=1;
    sigma2=1;
    beta=0;
    
    rho_grid=[0:.005:.995].^.5;
    %rho_grid=sort([-rho_grid rho_grid(2:end)]);
    pi_grid=[0.01:.01:5].^2;
    
    quantile_grid=[0.01:0.01:0.99];
    
    %rho_grid=[0:.05:.995].^.5;
    %pi_grid=[0.1:.1:5].^2;    
    
    containment_95_mean=NaN(length(pi_grid),length(rho_grid));
    containment_90_mean=NaN(length(pi_grid),length(rho_grid));
    
    draw_base=randn(sims,2);
    draw_base2=randn(sims,2);
    m1=1;


for m1=1:length(rho_grid)
    m1
    rho=rho_grid(m1);
    sigma12=sigma1*sigma2*rho;
    Omega=[sigma1^2 sigma12;...
        sigma12 sigma2^2];
    draw=draw_base*Omega^.5;
    draw2=draw_base2*Omega^.5;
    parfor n=1:length(pi_grid)
        pi_n=pi_grid(n);
        xi=draw+[beta*pi_n*ones(sims,1) pi_n*ones(sims,1)];
        xi2=draw2+[beta*pi_n*ones(sims,1) pi_n*ones(sims,1)];
        tau=pi^.5/(2^.5*sigma2)*exp(xi(:,2).^2/(2*sigma2^2)).*erfc(xi(:,2)/(2^.5*sigma2));
        beta_hat=tau.*(xi(:,1)-sigma12/sigma2^2*xi(:,2))+sigma12/sigma2^2;
        beta_hat_IV=xi2(:,1)./xi2(:,2);
        beta_hat_Full=(xi2(:,1).*xi2(:,2)+sigma12)./(xi2(:,2).^2+sigma2^2);
        
        %Check containment of unbiased estimator in Anderson-Rubin
        %Confidence set
        AR_vec=(xi(:,1)-beta_hat.*xi(:,2)).^2./(sigma1^2-2*sigma12*beta_hat+sigma2^2.*beta_hat.^2);
        containment_95_mean(n,m1)=mean(AR_vec<chi2inv(.95,1));
        containment_90_mean(n,m1)=mean(AR_vec<chi2inv(.9,1));

    end
end
