clear
%sims=10^6;
sims=10^2;
rng(1);

worker_count=24;
while worker_count>=12
    try
        parpool('local',worker_count)
    end
    n = numlabs;
    if n==worker_count
        worker_count=0;
    else
        worker_count=worker_count-2;
    end
end

try
    load simrecord4
end

if exist('m1')==0
    sigma1=1;
    sigma2=1;
    beta=0;
    
    rho_grid=[0:.005:.995].^.5;
    %rho_grid=sort([-rho_grid rho_grid(2:end)]);
    pi_grid=[0.01:.01:5].^2;
    
    quantile_grid=[0.01:0.01:0.99];
    
    %rho_grid=[0:.05:.995].^.5;
    %pi_grid=[0.1:.1:5].^2;
    
    mean_beta_hat=NaN(length(pi_grid),length(rho_grid));
    mean_beta_hat_IV=NaN(length(pi_grid),length(rho_grid));
    mean_beta_hat_Full=NaN(length(pi_grid),length(rho_grid));
    median_beta_hat=NaN(length(pi_grid),length(rho_grid));
    median_beta_hat_IV=NaN(length(pi_grid),length(rho_grid));
    median_beta_hat_Full=NaN(length(pi_grid),length(rho_grid));
    
    deviation_quantile_store_IV=zeros(length(quantile_grid),length(rho_grid),length(pi_grid));
    deviation_quantile_store_Full=zeros(length(quantile_grid),length(rho_grid),length(pi_grid));
    deviation_quantile_store_U=zeros(length(quantile_grid),length(rho_grid),length(pi_grid));
    
    containment_95_mean=NaN(length(pi_grid),length(rho_grid));
    containment_90_mean=NaN(length(pi_grid),length(rho_grid));
    
    MAD=NaN(length(pi_grid),length(rho_grid));
    MAD_Full=NaN(length(pi_grid),length(rho_grid));
    
    KS_IV=NaN(length(pi_grid),length(rho_grid));
    KS_IV_p=NaN(length(pi_grid),length(rho_grid));
    KS_Full=NaN(length(pi_grid),length(rho_grid));
    KS_Full_p=NaN(length(pi_grid),length(rho_grid));
    draw_base=randn(sims,2);
    draw_base2=randn(sims,2);
    m1=1;
else
    load Uniform_performance_results_1Msims
end

while m1<=length(rho_grid)
    m1
    rho=rho_grid(m1);
    sigma12=sigma1*sigma2*rho;
    Omega=[sigma1^2 sigma12;...
        sigma12 sigma2^2];
    draw=draw_base*Omega^.5;
    draw2=draw_base2*Omega^.5;
    parfor n=1:length(pi_grid)
        
        
        pi_n=pi_grid(n);
        xi=draw+[beta*pi_n*ones(sims,1) pi_n*ones(sims,1)];
        xi2=draw2+[beta*pi_n*ones(sims,1) pi_n*ones(sims,1)];
        tau=pi^.5/(2^.5*sigma2)*exp(xi(:,2).^2/(2*sigma2^2)).*erfc(xi(:,2)/(2^.5*sigma2));
        beta_hat=tau.*(xi(:,1)-sigma12/sigma2^2*xi(:,2))+sigma12/sigma2^2;
        beta_hat_IV=xi2(:,1)./xi2(:,2);
        beta_hat_Full=(xi2(:,1).*xi2(:,2)+sigma12)./(xi2(:,2).^2+sigma2^2);
        
        mean_beta_hat(n,m1)=mean(beta_hat);
        mean_beta_hat_IV(n,m1)=mean(beta_hat_IV);
        mean_beta_hat_Full(n,m1)=mean(beta_hat_Full);
        median_beta_hat(n,m1)=median(beta_hat);
        median_beta_hat_IV(n,m1)=median(beta_hat_IV);
        median_beta_hat_Full(n,m1)=median(beta_hat_Full);
        
        %Store quantiles of deviation from true parameter value
        deviation_quantile_store_IV(:,m1,n)=quantile(abs(beta_hat_IV-beta),quantile_grid);
        deviation_quantile_store_Full(:,m1,n)=quantile(abs(beta_hat_Full-beta),quantile_grid);
        deviation_quantile_store_U(:,m1,n)=quantile(abs(beta_hat-beta),quantile_grid);
        
        
%         %Store quantiles of deviation from median parameter estimate
%         deviation_quantile_store_IV(:,m1,n)=quantile(abs(beta_hat_IV-median_beta_hat_IV(n,m1)),quantile_grid);
%         deviation_quantile_store_Full(:,m1,n)=quantile(abs(beta_hat_Full-median_beta_hat_Full(n,m1)),quantile_grid);
%         deviation_quantile_store_U(:,m1,n)=quantile(abs(beta_hat-median_beta_hat(n,m1)),quantile_grid);
        
        [h,p,k]=kstest2(abs(beta_hat_IV-beta),abs(beta_hat-beta),'Tail','larger');
        KS_IV(n,m1)=k;
        KS_IV_p(n,m1)=p;
        [h,p,k]=kstest2(abs(beta_hat-beta),abs(beta_hat_Full-beta),'Tail','larger');
        KS_Full(n,m1)=k;
        KS_Full_p(n,m1)=p;
        
        MAD(n,m1)=mean(abs(beta_hat-beta));
        MAD_Full(n,m1)=mean(abs(beta_hat_Full-beta));
    end
    save Uniform_performance_results_1Msims
    m1=m1+1;
    save simrecord4 m1
end
median_ratio_IV=abs(median_beta_hat-beta)./abs(median_beta_hat_IV-beta);
median_ratio_Full=abs(median_beta_hat-beta)./abs(median_beta_hat_Full-beta);

median_diff_IV=abs(median_beta_hat-beta)-abs(median_beta_hat_IV-beta);
median_diff_Full=abs(median_beta_hat-beta)-abs(median_beta_hat_Full-beta);
median_diff_FullIV=abs(median_beta_hat_IV-beta)-abs(median_beta_hat_Full-beta);