%Simulate quantiles of absolute deviation from true parameter value.  These
%results underlie panels 2-4 for the univariate simulation results figure
%of Andrews and Armstrong (2016)
clear

sims=10^7;
quantile_grid=[0.1 0.5 0.9];
rng(1);

sigma1=1;
sigma2=1;
rho=0.95;
sigma12=sigma1*sigma2*rho;
beta=0;

Omega=[sigma1^2 sigma12;...
    sigma12 sigma2^2];
pi_grid=[0.05:.05:2].^2;
%pi_grid=-1;

mean_beta_hat=NaN(length(pi_grid),1);
mean_beta_hat_IV=NaN(length(pi_grid),1);
mean_beta_hat_Full=NaN(length(pi_grid),1);
median_beta_hat=NaN(length(pi_grid),1);
median_beta_hat_IV=NaN(length(pi_grid),1);
median_beta_hat_Full=NaN(length(pi_grid),1);
med_dev_quantile_beta_hat=NaN(length(pi_grid),length(quantile_grid));
med_dev_quantile_beta_hat_IV=NaN(length(pi_grid),length(quantile_grid));
med_dev_quantile_beta_hat_Full=NaN(length(pi_grid),length(quantile_grid));
true_dev_quantile_beta_hat=NaN(length(pi_grid),length(quantile_grid));
true_dev_quantile_beta_hat_IV=NaN(length(pi_grid),length(quantile_grid));
true_dev_quantile_beta_hat_Full=NaN(length(pi_grid),length(quantile_grid));
mean_dev_beta_hat_Full=NaN(length(pi_grid),1);
mean_dev_beta_hat=NaN(length(pi_grid),1);
    draw=randn(sims,2);
    draw=draw*Omega^.5;
for n=1:length(pi_grid)
    pi_n=pi_grid(n);
    xi=draw+[beta*pi_n*ones(sims,1) pi_n*ones(sims,1)];
    tau=pi^.5/(2^.5*sigma2)*exp(xi(:,2).^2/(2*sigma2^2)).*erfc(xi(:,2)/(2^.5*sigma2));
    beta_hat=tau.*(xi(:,1)-sigma12/sigma2^2*xi(:,2))+sigma12/sigma2^2;
    beta_hat_IV=xi(:,1)./xi(:,2);
    beta_hat_Full=(xi(:,1).*xi(:,2)+sigma12)./(xi(:,2).^2+sigma2^2);
    
    mean_beta_hat(n,1)=mean(beta_hat);
    mean_beta_hat_IV(n,1)=mean(beta_hat_IV);
    mean_beta_hat_Full(n,1)=mean(beta_hat_Full);
    median_beta_hat(n,1)=median(beta_hat);
    median_beta_hat_IV(n,1)=median(beta_hat_IV);
    median_beta_hat_Full(n,1)=median(beta_hat_Full);
    med_dev_quantile_beta_hat(n,:)=quantile(abs(beta_hat-median_beta_hat(n,1)),quantile_grid);
    med_dev_quantile_beta_hat_IV(n,:)=quantile(abs(beta_hat_IV-median_beta_hat_IV(n,1)),quantile_grid);
    med_dev_quantile_beta_hat_Full(n,:)=quantile(abs(beta_hat_Full-median_beta_hat_Full(n,1)),quantile_grid);    
    
    true_dev_quantile_beta_hat(n,:)=quantile(abs(beta_hat-beta),quantile_grid);
    true_dev_quantile_beta_hat_IV(n,:)=quantile(abs(beta_hat_IV-beta),quantile_grid);
    true_dev_quantile_beta_hat_Full(n,:)=quantile(abs(beta_hat_Full-beta),quantile_grid);    
    
    mean_dev_beta_hat(n,1)=mean(abs(beta_hat));
    mean_dev_beta_hat_Full(n,1)=mean(abs(beta_hat_Full));
    
    F_mean(n,:)=mean(xi(:,2).^2/sigma2^2);
end

Estim_mat=[beta_hat beta_hat_IV beta_hat_Full];

if rho==0.1
    save Univariate_performance_rho1
elseif rho==0.5
    save Univariate_performance_rho5    
elseif rho==0.95
    save Univariate_performance_rho95    
end
